#include "SDLConsole.h"

// Template for declaring multidimensional arrays
template <class T>
T** Create2DArray(Uint16 X, Uint16 Y) {
	T **newArray = new T * [X];
	
	for(Uint16 i = 0; i < X; i++)
		newArray[i] = new T[Y];

	return newArray;
}

// Returns an SDL screen for the text console.
SDL_Surface SDLConsole::CreateScreen(Uint16 width, Uint16 height) {
	// update private class variables
	SDLConsole::screenWidth		= width;
	SDLConsole::screenHeight	= height;

	// determine the size of the screen in pixels
	screenPxWidth	= width * CHAR_WIDTH;
	screenPxHeight	= height * CHAR_HEIGHT;

	// create arrays to hold the byte contents of the screen
	charMap = Create2DArray<unsigned char>(width, height);
	colorMap = Create2DArray<unsigned char>(width, height);

	// initialize both arrays
	for(Uint16 x = 0; x < width; x++)
		for(Uint16 y = 0; y < height; y++)
			charMap[x][y] = colorMap[x][y] = 0;
	
	// initialize palette
	Color black;
	black.Red = 0;
	black.Green = 0;
	black.Blue = 0;
	for(Uint16 i = 0; i < COLORS; i++) {
		palette[i] = black;
	}

	// create a screen and return it
	screen = SDL_SetVideoMode(screenPxWidth, screenPxHeight, 32, SDL_SWSURFACE);
	return *screen;
}