#include "SDLConsole.h"

void SDLConsole::Clear() {
	// clear out char and color maps
	for(Uint16 x = 0; x < screenWidth; x++)
		for(Uint16 y = 0; y < screenHeight; y++)
			charMap[x][y] = colorMap[x][y] = 0;
}

void SDLConsole::ClearRegion(Uint8 chr, Uint8 pal, Uint16 X1, Uint16 Y1, Uint16 X2, Uint16 Y2) {
	// replace part of the screen with something
	for(Uint16 x = X1; x < (X2+1); x++)
		for(Uint16 y = Y1; y < (Y2+1); y++) {
			charMap[x][y] = chr;
			colorMap[x][y] = pal;
		}
}

void SDLConsole::Plot(Uint8 chr, Uint8 pal, Uint16 x, Uint16 y, bool update) {
	Plot(chr, pal, x, y);
	if(update) Update(x, y);
}

void SDLConsole::Plot(Uint8 chr, Uint8 pal, Uint16 x, Uint16 y) {
	charMap[x][y] = chr;
	colorMap[x][y] = pal;
}